deleteVariables("$PublicWand::*");
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$PublicWand::PrefsLoaded)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		RTB_registerPref("Admin Only", "PublicWand", "Pref::PublicWand::AdminOnly", "bool", "Tool_PublicWand", 1, 0, 0);
		RTB_registerPref("Max Bricks (Admin)", "PublicWand", "Pref::PublicWand::MaxBricks", "int 0 50000", "Tool_PublicWand", 5000, 0, 0);
		RTB_registerPref("Max Bricks (Non-Admin)", "PublicWand", "Pref::PublicWand::MaxBricksB", "int 0 50000", "Tool_PublicWand", 500, 0, 0);
		RTB_registerPref("Selecting Timeout (Admin)", "PublicWand", "Pref::PublicWand::SelectionTimeout", "int 0 60", "Tool_PublicWand", 1, 0, 0);
		RTB_registerPref("Selecting Timeout (Non-Admin)", "PublicWand", "Pref::PublicWand::SelectionTimeoutB", "int 0 60", "Tool_PublicWand", 3, 0, 0);
		RTB_registerPref("Max Flood Bypass", "PublicWand", "Pref::PublicWand::FloodIgnore", "int 0 50000", "Tool_PublicWand", 50, 0, 0);
		RTB_registerPref("Trust Required", "PublicWand", "Pref::PublicWand::TrustLevel", "list None " @ $TrustLevel::None @ " Build " @ $TrustLevel::Build @ " Full " @ $TrustLevel::Full @ " You " @ $TrustLevel::You, "Tool_PublicWand", 2, 0, 0);
		$PublicWand::PrefsLoaded = true;
	}
}
else
{
	$Pref::PublicWand::AdminOnly = true;
	$Pref::PublicWand::MaxBricks = 5000;
	$Pref::PublicWand::MaxBricksB = 500;
	$Pref::PublicWand::TrustLevel = 2;
	$Pref::PublicWand::SelectionTimeout = 0;
	$Pref::PublicWand::SelectionTimeoutB = 3;
	$Pref::PublicWand::FloodIgnore = 50;
}
$Pref::PublicWand::HighlightColor = getClosestPaintColor("1 0.5 0 1");
datablock particleData(PublicWandExplosionParticle:DuplorcatorExplosionParticle) {
	colors[0]          = "1 0.7 0.3 0.9";
	colors[1]          = "1 0.5 0.2 0.7";
	colors[2]          = "1 0.4 0 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(PublicWandExplosionEmitter:DuplorcatorExplosionEmitter) {
	particles        = PublicWandExplosionParticle;
};

datablock explosionData(PublicWandExplosion:DuplorcatorExplosion) {
	emitter[0]       = PublicWandExplosionEmitter;
	lightStartColor  = "1 0.4 0 1";
};

datablock projectileData(PublicWandProjectile:DuplorcatorProjectile) {
	explosion        = PublicWandExplosion;
};

datablock particleData(PublicWandParticleA:DuplorcatorParticleA) {
	colors[0]          = "1 0.5 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.4 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(PublicWandEmitterA:DuplorcatorEmitterA) {
	particles        = PublicWandParticleA;
};

datablock particleData(PublicWandParticleB:DuplorcatorParticleB) {
	colors[0]          = "1 0.6 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.3 0.5";
	textureName        = "base/data/particles/dot";
};

datablock particleEmitterData(PublicWandEmitterB:DuplorcatorEmitterB) {
	particles        = PublicWandParticleB;
};

datablock itemData(PublicWandItem:DuplorcatorItem) {
   className       = "ItemData"; //stop creating errors b-baka
	colorShiftColor = "1 0.5 0 1";
	image           = "PublicWandImage";
	uiName          = "Public Wand";
};

datablock shapeBaseImageData(PublicWandImage : wandImage) {
	projectile = PublicWandProjectile;
	showBricks = true;
	colorShiftColor = "1 0.5 0 1";
	item = PublicWandItem;
	stateEmitter[1] = PublicWandEmitterA;
	stateEmitter[3] = PublicWandEmitterB;
};
function PublicWandImage::onStopFire(%this,%player)
{
	%player.stopThread(2);
}
function PublicWandImage::onFire(%this,%player)
{
	%player.playThread(2,armAttack);

	%start = %player.getEyePoint();
	%end = vectorAdd(%player.getEyePoint(),VectorScale(%player.getEyeVector(),10));
	%masks = %this.projectile.mask;
	%ray = ContainerRayCast(%start,%end,%masks,%player);
	if(isObject(%ray))
	{
		%p = new Projectile()
		{
			datablock = %this.projectile;
			initialPosition = restWords(%ray);
		};
		%p.explode();
		if(%ray.getClassName() !$= "FxDtsBrick")
			return;
		if(!%player.client.isAdmin && $Pref::PublicWand::AdminOnly)
		{
			commandToClient(%player.client,'centerPrint',"<color:99AAAA>You must be an \c4Admin<color:99AAAA> to use the <color:ffa500>Public Wand",3);
			return;
		}
		if(getTrustLevel(firstWord(%ray),%player) < $Pref::PublicWand::TrustLevel)
		{
			if(%ray.getGroup().bl_id != 888888)
			{
				commandtoclient(%player.client,'centerPrint',%ray.getGroup().name @ " does not trust you enough to do that.",3);
				return;
			}
			else
			{
				commandtoclient(%player.client,'centerPrint',"These bricks are already public",3);
				return;
			}
		}
		if(%player.client.isAdmin)
			%length = $Pref::PublicWand::SelectionTimeout*1000;
		else
			%length = $Pref::PublicWand::SelectionTimeoutB*1000;
		if(getSimTime() - %player.lastPubWandTime < %length)
		{
			messageClient(%player.client,'MsgPlantError_Flood');
			%timeout = getSimTime() - %player.lastPubwandTime;
			%timeout = %length - %timeout;
			%timeout /= 1000;
			%timeout = mCeil(%timeout);
			%timeout = %timeout @ " <color:99AAAA>" @ (%timeout > 1 ? "seconds":"second");
			commandtoClient(%player.client,'centerprint',"<color:99AAAA>You must wait \c4" @ %timeout @ "<color:99AAAA> before selecting again",3);
			return;
		}
		%player.lastPubWandTime = getSimTime();
		%stack = %ray.getPubStack(%player);
		%stack.numBricks = %stack.getCount();
		%b = (%stack.numbricks != 1  ? "bricks":"brick");
		for(%i=0;%i<%stack.numBricks;%i++)
		{
		   %brick = %stack.getObject(%i);
		   %group = %brick.getGroup();
		   if(%group.bl_id != 888888)
         {
            %group.remove(%brick);
            BrickGroup_888888.add(%brick);
         }
		}
		bottomPrint(%player.client,"<color:ffa500>Public Wand<br><color:ffa500>" @ %stack.numBricks SPC %b @ "<color:99AAAA> converted",3);
		if(%stack.err $= "Limit")
			messageClient(%player.client,'MsgPlantError_Limit');
	}
}
function FxDtsBrick::getPubStack(%brick,%player)
{
	%initialPos = %brick.getPosition();
	if(getTrustLevel(%brick,%player) < $Pref::PublicWand::TrustLevel)
		return;
	%stack = new SimSet();
	%stack.add(%brick);
	%stack.brick0 = %brick.toSaveStr(%initialPos);
	if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate) //marble's hack because logic bricks lel
	{
      if(isEventPending(%brick.highlightColorReset))
         cancel(%brick.highlightColorReset);
      else
      {
         %color = %brick.getColorID();
         %colorFX = %brick.getColorFxID();
         %brick.setColor($Pref::PublicWand::HighlightColor);
         %brick.setColorFX(3);
         %brick.originalColor = %color;
         %brick.originalColorFX = %colorFX;
      }
      %brick.highlightColorReset = %brick.schedule(3000,restoreOrignalColors);
	}
	%final = 1;
	for(%current = 0; %current != %final; %current++)
	{
		if((%player.client.isAdmin && $Pref::PublicWand::MaxBricks <= %stack.getCount()) || (!%player.client.isAdmin && $Pref::PublicWand::MaxBricksB <= %stack.getCount()))
		{
			%stack.err = "Limit";
			return %stack;
		}
		%brick = %stack.getObject(%current);
		if(%current)
		{
			for(%i=0;%i<%brick.getNumDownBricks();%i++)
			{
				%appendBrick = %brick.getDownBrick(%i);
				if(%stack.isMember(%appendBrick) || getTrustLevel(%appendBrick,%player) < $Pref::PublicWand::TrustLevel)
					continue;
            if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
            {
               if(isEventPending(%appendBrick.highlightColorReset))
                  cancel(%appendBrick.highlightColorReset);
               else
               {
                  %color = %appendBrick.getColorID();
                  %colorFX = %appendBrick.getColorFxID();
                  %appendBrick.setColor($Pref::PublicWand::HighlightColor);
                  %appendBrick.setColorFX(3);
                  %appendBrick.originalColor = %color;
                  %appendBrick.originalColorFX = %colorFX;
               }
               %appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
            }
				%stack.add(%appendBrick);
				%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
				%final++;
			}
		}
		for(%i=0;%i<%brick.getNumUpBricks();%i++)
		{
			%appendBrick = %brick.getUpBrick(%i);
			if(%stack.isMember(%appendBrick) || getTrustLevel(%appendBrick,%player) < $Pref::PublicWand::TrustLevel)
					continue;
         if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
         {
            if(isEventPending(%appendBrick.highlightColorReset))
               cancel(%appendBrick.highlightColorReset);
            else
            {
               %color = %appendBrick.getColorID();
               %colorFX = %appendBrick.getColorFxID();
               %appendBrick.setColor($Pref::PublicWand::HighlightColor);
               %appendBrick.setColorFX(3);
               %appendBrick.originalColor = %color;
               %appendBrick.originalColorFX = %colorFX;
            }
            %appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
         }
			%stack.add(%appendBrick);
			%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
			%final++;
		}
	}
	return %stack;
}
function servercmdPublicWand(%client)
{
	if(!isObject(%client.player))
		return;
	%client.player.updateArm(PublicWandImage);
	%client.player.mountImage(PublicWandImage,0);
}
function servercmdpub(%client)
{
	servercmdPublicWand(%client);
}